----------------------------------------------------------------------------------------------------
-- DotFocus
-- Author: Snowcloud (Mic�h - Antonidas)
-- Codebase by: Meranannon (Insane - Vol'jin)
----------------------------------------------------------------------------------------------------

-- namespace
local DF = DOF_namespace
local _
DF.dotPowerDatas={}

-- spell names
DF.SavageRoarName, _, _, _, _, _ = GetSpellInfo(52610) 
DF.ProwlName, _, _, _, _, _ = GetSpellInfo(5215) 
DF.TigerFuryName, _, _, _, _, _ = GetSpellInfo(5217) 
DF.BloodTalonsName, _, _, _, _, _ = GetSpellInfo(155672) 
DF.BerzerkName, _, _, _, _, _ = GetSpellInfo(106951) 
DF.IncarnationName, _, _, _, _, _ = GetSpellInfo(102543) 
DF.RakeName, _, _, _, _, _ = GetSpellInfo(1822) 
DF.FeralFrenzyName, _, _, _, _, _ = GetSpellInfo(274837) 
DF.MoonfireName, _, _, _, _, _ = GetSpellInfo(164812) 
DF.SunfireName, _, _, _, _, _ = GetSpellInfo(164815) 
DF.MoonfireCatName, _, _, _, _, _ = GetSpellInfo(155625) 
DF.RakeDebufName, _, _, _, _, _ = GetSpellInfo(155722) 
DF.RipName, _, _, _, _, _ = GetSpellInfo(1079) 
DF.ThrashName, _, _, _, _, _ = GetSpellInfo(106830) 

-- combo point builder spells
DF_builders={}
DF_builders[5221] = true -- Shred
DF_builders[1822] = true -- Rake
DF_builders[274837] = true -- feral's frenzy
DF_builders[106785] = true -- swipe
DF_builders[155625] = true -- Moonfire
DF_builders[106830] = true -- Trash

-- finisher spells
DF_finishers={}
DF_finishers[52610] = true -- rugissement sauvage
DF_finishers[1079] = true -- d�chirure
DF_finishers[22568] = true -- morsure f�roce
DF_finishers[22570] = true -- estropier

-- Use dot power tracking (feral snapshotting) on these spells
-- show dot when: 2^0=tigers furor, 2^1=savage roar, 2^2=bloodtalons
DF_powerId={}
DF_powerId[1079]   = 2^0 + 2^1 + 2^2 -- rip spell and debuff
DF_powerId[106830] = 2^0 + 2^1 + 2^2 -- trash spell and debuff
DF_powerId[155722] = 2^0 + 2^1 + 2^2 -- rake debuff
DF_powerId[274838] = 2^0 + 2^1 + 2^2 -- ferals frenzy debuff
DF_powerId[155625] = 2^0 + 2^1       -- Moonfire Cat

-- Adds spells or objects to the spell selection listbox. Useful, if several IDs are for the same spell
-- ltype 1 for spells, ltype 2 for objects
DF.spellsListspecial ={
  {["texte"]=274837,["valeur"]="274837;274838",["alttexte"]="feral's Frenzy",["ltype"]=1},
  {["texte"]=1822,["valeur"]="1822;155722",["alttexte"]="Rake for Cat",["ltype"]=1},
  {["texte"]=106830,["valeur"]="106830",["alttexte"]="Trash for Cat",["ltype"]=1},
  {["texte"]=155625,["valeur"]="155625;8921",["alttexte"]="Moonfire for Cat",["ltype"]=1},
  {["texte"]=77758,["valeur"]="77758",["alttexte"]="Trash for Bear",["ltype"]=1},
  {["texte"]=164812,["valeur"]="164812",["alttexte"]="Moonfire for Bear",["ltype"]=1},
}

-- specify default durations for special spells
function DF:SetSpecialDefaultDurations()

  local _, _, _, hasJaggedWounds, _, _, _, _, _ = GetTalentInfo(5,2,GetActiveSpecGroup())
  DF:setDefautDuration(DF.RipName,hasJaggedWounds and 19.2 or 24.0)
  DF:setDefautDuration(DF.RakeName,hasJaggedWounds and 12.0 or 15.0)
  DF:setDefautDuration(DF.ThrashName,hasJaggedWounds and 12.0 or 15.0)
    
  DF:setDefautDuration(DF.SavageRoarName,36) 
  DF:setDefautDuration(DF.MoonfireName,22)
  DF:setDefautDuration(DF.SunfireName,18)
  DF:setDefautDuration(DF.MoonfireCatName,16)
 end
 
 -- Adds more IDs to a certain spell; semicolon separated list
 -- current spell number, search spell, replace or add value, true=add / false=replace
 function DF:AddSpecialSpellIDs(i)    
    DF:SetupGoodSpellsID(i, "274837", "274838", true) -- feral's frenzy
    DF:SetupGoodSpellsID(i, "1822", "155722", true) -- Rake
    DF:SetupGoodSpellsID(i, "8921", "155625", true) -- Moonfire Cat
 end
 
-- Define damage data for all spells that use dot power
DF.dotPowerDatas[DF.RakeDebufName]={
  base=99,        --  base damage
  baseap=0.30665, --  damage give by power attack
  basecp=0,       --  base damage per combo point (if spell use combo point, else zero)
  spellId=155722  -- spell ID
}
DF.dotPowerDatas[DF.RipName]={
  base=112.76,
  baseap=0.0484,
  basecp=320,
  spellId=1079  -- spell ID
}
DF.dotPowerDatas[DF.ThrashName]={
  base=686,
  baseap=0.0936,
  basecp=0,
  spellId=106830  -- spell ID
}
DF.dotPowerDatas[DF.FeralFrenzyName]={
  base=686,       -- TODO ??
  baseap=0.0936,  -- TODO ??
  basecp=0,
  spellId=274838  -- spell ID
}
DF.dotPowerDatas[DF.MoonfireCatName]={
  base=686,       -- TODO ??
  baseap=0.0936,  -- TODO ??
  basecp=0,
  spellId=155625  -- spell ID
} 
